<template>
    <div class="cont">
        <appBar />
        <sideDrawer />
        <v-card class="a">
            <v-card-title>用户设置</v-card-title>
            <v-card-subtitle>欢迎来到你的个性化世界！</v-card-subtitle>
            <v-row>
                <v-col cols="6">
                    <v-text-field label="昵称" class="px-4" dense v-model="nickName"></v-text-field>
                    <v-select
                        label="头像颜色"
                        class="px-4"
                        dense
                        :items="avatarColors"
                        v-model="colorChosen"
                    ></v-select>
                    <v-text-field
                        label="头像图标"
                        class="px-4"
                        dense
                        v-model="avatar"
                    ></v-text-field>
                    <v-subheader
                        >*注：图标列表可参见<a href="https://cdn.materialdesignicons.com/4.8.95/">
                            material design icons官网</a
                        >，右击获取。</v-subheader
                    >
                    <div class="rightcont">
                        <v-btn color="thirdary" class="white--text" @click="savechange">更新</v-btn>
                    </div>
                </v-col>
                <v-col cols="6">
                    <v-sheet tile color="white" width="150" height="150">
                        <v-subheader>目前头像：</v-subheader>
                        <v-avatar :color="colorChosen" class="ml-4">
                            <v-icon x-large color="white">{{ avatar }}</v-icon>
                        </v-avatar>
                    </v-sheet>
                </v-col>
            </v-row>
        </v-card>
    </div>
</template>

<script>
import appBar from "../basic/appBar";
import sideDrawer from "../basic/sideDrawer";
//import getUser from './getUser'
export default {
    name: "UserPage",
    components: {
        appBar,
        sideDrawer, //, getUser
    },
    data: () => ({
        userName: "",
        nickName: "",
        colorChosen: "",
        avatar: "",
        avatarColors: [
            { text: "正红", value: "red" },
            { text: "浓粉", value: "pink" },
            { text: "紫色", value: "purple" },
            { text: "蓝紫", value: "deep-purple" },
            { text: "靛蓝", value: "indigo" },
            { text: "湖蓝", value: "blue" },
            { text: "天蓝", value: "light-blue" },
            { text: "青蓝", value: "cyan" },
            { text: "青绿", value: "teal" },
            { text: "果绿", value: "green" },
            { text: "草绿", value: "light-green" },
            { text: "绿黄", value: "lime" },
            { text: "正黄", value: "yellow" },
            { text: "琥珀", value: "amber" },
            { text: "橙色", value: "orange" },
            { text: "橘红", value: "deep-orange" },
            { text: "棕色", value: "brown" },
            { text: "蓝灰", value: "blue-grey" },
            { text: "银灰", value: "grey" },
        ],
    }),
    methods: {
        savechange() {
            // validate
            if (this.nickName === "") {
                alert("昵称不能为空，请输入");
                return;
            }

            if (this.avatar === "") {
                alert("头像不能为空，请输入");
                return;
            }

            if (this.colorChosen === "") {
                alert("用户颜色不能为空，请输入");
                return;
            }

            this.$axios({
                method: "post",
                url: `/updateUser`,
                data: {
                    userName: this.userName,
                    nickName: this.nickName,
                    color: this.colorChosen,
                    avatar: this.avatar,
                },
            }).then(res => {
                if (res.status === 200) {
                    const data = res.data;
                    if (data.status === "UPDATE_SUCCESS") {
                        sessionStorage.setItem("nickName", this.nickName);
                        sessionStorage.setItem("userAvatar", this.avatar);
                        sessionStorage.setItem("userColor", this.colorChosen);

                        // this.$store.dispatch("setNickName", this.nickName);
                        // this.$store.dispatch("setUserAvatar", this.avatar);
                        // this.$store.dispatch("setUserColor", this.colorChosen);
                        this.$evtbus.$emit("User.UserInfoUpdated");
                        alert("修改成功");
                    } else {
                        alert("出错了！");
                    }
                    return;
                }

                alert("连接失败。\n请检查您的网络状态。");
            });
        },
    },
    mounted() {
        this.userName = this.$store.getters.userName;
        this.nickName = this.$store.getters.nickName;
        this.avatar = this.$store.getters.userAvatar;
        this.colorChosen = this.$store.getters.userColor;
    },
};
</script>

<style scoped>
.cont {
    background-color: #f8ffaa;
    height: 100%;
    width: 100%;
}
.a {
    top: 15vh;
    left: 20%;
    width: 50%;
    background-color: #7effbf;
}
.rightcont {
    display: flex;
    justify-content: flex-end;
}
</style>
